//+------------------------------------------------------------------+
//|                                                   exampleEA2.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict



extern double Lots =0.01;
extern double Difference =300;
extern int TrailingStop=0;
extern int Slippage=3;
double Trade_Balance = 1000;
double RecordedPrice;
string RecordedDirection;
bool res1;
bool res2;
bool res3;
bool res4;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   Comment("Balance: ", Trade_Balance);
   enterTrade();
//---
   return(INIT_SUCCEEDED);
  }
  
  
  
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
  
  
  
  
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
      //if(RecordedDirection == "Buy")
      //{
         //int takeProfit = RecordedPrice+Difference*Point;
         //int stopLoss = RecordedPrice-Difference*Point;
      //}
      
      static bool first = true;
       static int pre_OrdersTotal = 0;
       int _OrdersTotal = OrdersTotal();
       Alert(_OrdersTotal);
    
       // If this is the first launch of the Expert, we don't know the amount of orders on the previous tick.
       // So just remeber it, mark that the first launch has been happened, and exit.
       if ( first )
       {
           pre_OrdersTotal = _OrdersTotal;
           first = false;
       }
    
       // Compare the amount of positions on the previous tick with the current amount
       // If it has been changed, display message
       if ( _OrdersTotal > pre_OrdersTotal ) 
           Alert( "The amount of positions increased! There were - ", pre_OrdersTotal, 
                                                            ", there are now - ", _OrdersTotal );
    
       if ( _OrdersTotal < pre_OrdersTotal )
           Alert( "The amount of positions decreased! There were - ", pre_OrdersTotal, 
                                                            ", there are now - ", _OrdersTotal );
    
       // Memorize the amount of positions
       pre_OrdersTotal = _OrdersTotal;
      
   
  }
  
  
  
  
  
//+------------------------------------------------------------------+
//| Expert special function                                             |
//+------------------------------------------------------------------+
void enterTrade()
  {
   
   if((iMA(NULL,0,50,0,MODE_EMA,PRICE_CLOSE,0)<Ask))                                                                          // Here is your open buy rule
   {
      
      res1 = OrderSend(Symbol(), OP_BUY, Lots, NormalizeDouble(Ask, Digits), Slippage, NormalizeDouble(Ask-Difference*Point, Digits), NormalizeDouble(Ask+Difference*Point, Digits), NULL, 0, 0, Green);                    // Enter a buy trade
      if(res1 == false){ Alert(GetLastError());} else{ RecordedPrice = Ask; RecordedDirection = "Buy"; }
      
      
      res2 = OrderSend(Symbol(), OP_SELLSTOP, Lots*2, NormalizeDouble(Ask-Difference*Point, Digits), Slippage, NormalizeDouble(Ask, Digits), NormalizeDouble(Ask-Difference*Point*2, Digits), NULL, 0, 0, Red);                    // Enter a buy trade
      if(res2 == false){ Alert(GetLastError());} else{  }
      
   }
   else if((iMA(NULL,0,50,0,MODE_EMA,PRICE_CLOSE,0)>Bid))                                                                          // Here is your open Sell rule
   {
      
      res3 = OrderSend(Symbol(), OP_SELL, Lots, NormalizeDouble(Bid, Digits), Slippage, NormalizeDouble(Bid+Difference*Point, Digits), NormalizeDouble(Bid-Difference*Point, Digits), NULL, 0, 0, Red);                    // Enter a buy trade
      if(res3 == false){ Alert(GetLastError());} else{  RecordedPrice = Bid; RecordedDirection = "Sell";  }
      
      res4 = OrderSend(Symbol(), OP_BUYSTOP, Lots*2, NormalizeDouble(Bid+Difference*Point, Digits), Slippage, NormalizeDouble(Bid, Digits), NormalizeDouble(Bid+Difference*Point*2, Digits), NULL, 0, 0, Green);                    // Enter a buy trade
      if(res4 == false){ Alert(GetLastError());} else{  }                                                                      // Give alert if error
       
   }
                              
  }
  


  
  

bool isOrderExist(const int _ticket)
 {
    if(OrderSelect(_ticket,SELECT_BY_TICKET)){
       return(OrderCloseTime()==0);
    }else{
       int error=GetLastError();
       return(error!=4108 && error!=4051);
    }
 }


//+------------------------------------------------------------------+
